import "../compat/json";
import "../compat/format";
import { ezAlert, ezQuery, ezBadge } from "../compat/ezq";

window.carouselPosition = 0;
window.carouselMax = 0;

export async function showProvided(element) {
  let provide = element.id;

  let mediaContents;
  try {
    mediaContents = JSON.parse(provide);
  } catch {}
  //si media content est defis c que le provied est des photos/video
  //sinon c autre chose genre du texte
  if (mediaContents) {
    let thumbsnailAvailable = false;
    for (let i = 0; i < mediaContents.length; i++) {
      if (mediaContents[i]["type"] == "thumbsnail") {
        thumbsnailAvailable = true;
        let thumbsnail = createMediaElement(mediaContents[i]);
        thumbsnail.style.width = "50px";
        thumbsnail.style.height = "auto";
        element.appendChild(thumbsnail);
        element.onclick = showLargeSubmissions;
      }
    }
    if (!thumbsnailAvailable) {
      let text = document.createElement("p");
      text.textContent = "Pas de miniature disponible pour les médias actuels";
      element.appendChild(text);
    }
  } else if (provide.length > 66) {
    // Show a text icon instead of the full text, with a click option
    let icon = document.createElement("i");
    icon.className = "fas fa-file-alt"; // Font Awesome text icon
    icon.style.cursor = "pointer";
    icon.style.fontSize = "24px";
    icon.onclick = function () {
      showTextPopup(provide);
    };
    element.appendChild(icon);
  } else {
    // Show the text directly
    let text = document.createElement("p");
    text.textContent = provide;
    text.style.wordWrap = "break-word";
    element.appendChild(text);
  }
}

function showTextPopup(text) {
  // Create the overlay
  let overlay = document.createElement("div");
  overlay.style.position = "fixed";
  overlay.style.left = "0";
  overlay.style.top = "0";
  overlay.style.width = "100%";
  overlay.style.height = "100%";
  overlay.style.backgroundColor = "rgba(0, 0, 0, 0.5)"; // Semi-transparent background
  overlay.style.zIndex = "999";
  overlay.onclick = function (event) {
    if (event.target === overlay) {
      document.body.removeChild(overlay);
    }
  };

  // Create the popup container
  let popup = document.createElement("div");
  popup.style.position = "fixed";
  popup.style.left = "50%";
  popup.style.top = "50%";
  popup.style.transform = "translate(-50%, -50%)";
  popup.style.backgroundColor = "#f9f9f9";
  popup.style.border = "1px solid #ccc";
  popup.style.borderRadius = "8px"; // Rounded corners
  popup.style.padding = "20px";
  popup.style.zIndex = "1000";
  popup.style.width = "80%";
  popup.style.maxWidth = "600px"; // Set a maximum width for the box
  popup.style.height = "auto";
  popup.style.maxHeight = "40%";
  popup.style.overflowY = "auto";
  popup.style.boxShadow = "0 4px 8px rgba(0, 0, 0, 0.1)"; // Add shadow for modern look

  // Create the text element
  let textElement = document.createElement("p");
  textElement.textContent = text;
  textElement.style.wordWrap = "break-word"; // Ensure text wraps
  textElement.style.margin = "0";
  textElement.style.color = "#333"; // Dark text color
  textElement.style.fontFamily = "Arial, sans-serif"; // Modern font
  popup.appendChild(textElement);

  // Create the close button
  let closeButton = document.createElement("button");
  closeButton.textContent = "x";
  closeButton.className = "close";
  closeButton.ariaLabel = "Close";
  closeButton.style.position = "absolute";
  closeButton.style.top = "0px";
  closeButton.style.right = "5px";
  closeButton.style.cursor = "pointer";
  closeButton.onclick = function () {
    document.body.removeChild(overlay);
  };
  popup.appendChild(closeButton);

  // Append the popup to the overlay
  overlay.appendChild(popup);

  // Append the overlay to the body
  document.body.appendChild(overlay);
}



function createMediaElement(mediaContent) {
  let htmlElement;
  if (mediaContent["type"] == "video/webm") {
    htmlElement = document.createElement("video");
    htmlElement.controls = true;
    htmlElement.type = "video/webm";
  } else if (
    mediaContent["type"] == "image/png" ||
    mediaContent["type"] == "thumbsnail"
  ) {
    htmlElement = document.createElement("img");
    htmlElement.type = "image/png";
  }
  htmlElement.src = "/files/" + mediaContent["location"];

  return htmlElement;
}

function showLargeSubmissions(_event) {
  window.carouselPosition = 0;
  let mediaContents;
  try {
    mediaContents = JSON.parse(_event.srcElement.id);
  } catch {
    mediaContents = JSON.parse(_event.srcElement.parentElement.id);
  }
  let decalage = false;
  let images = mediaContents;

  window.carouselMax = mediaContents.length - 1;
  let imagesHTML =
    "<section class='slider-wrapper'><ul class='slides-container list-unstyled' style:'list-style: none !important;' id='slides-container'>";
  for (let i = 0; i < mediaContents.length; i++) {
    if (mediaContents[i]["type"] != "thumbsnail") {
      let element = createMediaElement(mediaContents[i]);
      element.style.width = "100%";
      element.style.objectFit = "contain";
      element.style.height = "500px";

      let lambda = document.createElement("div");
      lambda.append(element);
      imagesHTML +=
        `<li class="slide ` +
        (decalage ? i - 1 : i) +
        "slide" +
        `" style="min-height:50%">`;
      imagesHTML += lambda.innerHTML;
      imagesHTML += `</li>`;
    } else {
      decalage = true;
    }
  }
  imagesHTML += "</ul></section>";
  imagesHTML +=
    "<img src onerror='reloadCarousel(this.parentElement);'><button class='btn btn-primary carousel__navigation-button slide-arrow-prev' id='slide-arrow-prev' onclick='downCarousel(this)' style='display:block;position:absolute;top:40%;left:1rem;'>" +
    `<svg viewBox="0 0 100 100"><path d="M 50,0 L 60,10 L 20,50 L 60,90 L 50,100 L 0,50 Z" class="arrow" fill="white" transform="translate(15,0) rotate(0)"></path></svg>` +
    "</button><button style='position:absolute;top:40%;right:1rem;' class='btn btn-primary carousel__navigation-button slide-arrow-next' id='slide-arrow-next' onclick='upCarousel(this)'>" +
    `<svg viewBox="0 0 100 100"><path d="M 50,0 L 60,10 L 20,50 L 60,90 L 50,100 L 0,50 Z" class="arrow" fill="white" transform="translate(85,100) rotate(180)"></path></svg>` +
    "</button>";
  ezAlert({
    title: "Visioneurs",
    body: imagesHTML,
    button: "retour",
    additionalClassMain: "FullSizeCarousel",
  });
  document.getElementsByClassName("modal-dialog")[0].style.listStyle = "none";
}

window.upCarousel = function (self) {
  window.carouselPosition += 1;
  if (window.carouselPosition != window.carouselMax - 1) {
    window.reloadCarousel(self.parentElement);
    self.parentElement.getElementsByClassName("slide-arrow-prev")[0].hidden =
      false;
  } else {
    window.reloadCarousel(self.parentElement);
    self.parentElement.getElementsByClassName("slide-arrow-next")[0].hidden =
      true;
    self.parentElement.getElementsByClassName("slide-arrow-prev")[0].hidden =
      false;
  }
};

window.downCarousel = function (self) {
  window.carouselPosition -= 1;

  if (window.carouselPosition != 0) {
    window.reloadCarousel(self.parentElement);
    self.parentElement.getElementsByClassName("slide-arrow-next")[0].hidden =
      false;
  } else {
    window.reloadCarousel(self.parentElement);
    self.parentElement.getElementsByClassName("slide-arrow-prev")[0].hiddend =
      true;
    self.parentElement.getElementsByClassName("slide-arrow-next")[0].hidden =
      false;
  }
};

window.reloadCarousel = function (element) {
  if (window.carouselPosition == 0) {
    element.getElementsByClassName("slide-arrow-prev")[0].hidden = true;
  }
  if (window.carouselMax == 1) {
    element.getElementsByClassName("slide-arrow-next")[0].hidden = true;
  }

  for (let i = 0; i < window.carouselMax; i++) {
    if (i == window.carouselPosition) {
      element.getElementsByClassName(i + "slide")[0].hidden = false;
    } else {
      element.getElementsByClassName(i + "slide")[0].hidden = true;

      let child = element.getElementsByClassName(i + "slide")[0].firstChild;

      if (child.nodeName == "VIDEO") {
        child.pause();
      }
    }
  }
};
