import time
import os
from CTFd import create_app
from CTFd.models import Submissions, db, Challenges
from moviepy.editor import VideoFileClip
from flask import request, current_app
from PIL import Image, ExifTags
import json
from CTFd.utils.modes import get_model

def processFiles(submission):
    try:
        try:
            response = json.loads(submission.response)
            vraietype = json.loads(submission.vraiType)
            files = json.loads(submission.files_data)  # Convert back to a list of dictionaries

        except:
            print("ERREUR de chargement des données depuis la db (données vides ou corrompues)")
            submission.provided="Erreur de traitement de la soumission"
            db.session.commit()
            return

        


        width = 800
        widthThumbsnail = 150
        fps = 24
        if (submission.heavyData):
            width = 500
            fps = 15
        size = 0
        for i in range(len(files)):
            print("hello")
            response[i]["location"] = response[i]["location"].split('.')[0] + "." +vraietype[i].lower()
            path = current_app.config.get("UPLOAD_FOLDER")+"/"+response[i]["location"]
            try:
                size += os.path.getsize(path)
            except:
                #il tente de parcourire les fichier temporaire
                size += 0
        
        for i in range(len(files)):
            print("holla")
            print(i)
            response[i]["location"] = response[i]["location"].split('.')[0] + "." + vraietype[i].lower()
            print("response check")
            print(response)
            response[i]["type"] = str(files[i]).split('\'')[3]
            print(response)
            path = current_app.config.get("UPLOAD_FOLDER") + "/" + response[i]["location"]
            directory = ""
            for x in path.split('/')[0:-1]:
                directory += "/" + x
        
            #opperation a effectuer seulement sur la thumbsnail:x``
            if i == 0:
                if files[i]["content_type"].find("video") != -1:
                    print("video0")
                    try:
                        clip = VideoFileClip(path)
                    except:
                        print("ERREUR de path")
                        submission.provided="Erreur de traitement de la soumission"
                        db.session.commit()
                        return
                    if clip.rotation == 90:
                        clip = clip.resize(clip.size[::-1])
                        clip.rotation = 0
                    
                    
                    
                        


                    os.remove(path)
                    path = path.split('.')[0]+".png"
                    work = False
                    for x in range(10):
                        try:
                            clip.save_frame(path, t = 0.2*x)
                        except:
                            
                            pass
                    
                    print("changing type to image/png")
                    print(response)
                    response[i]["type"] = "image/png"
                    print(response)
                #we also want to reduce the size of videos thumbsnail
                if files[i]["content_type"].find("image") or files[i]["content_type"].find("video") != -1:
                    print("image0")
                    image = Image.open(path)
                    os.remove(path)
                    #changer orientation
                    try:
                        for orientation in ExifTags.TAGS.keys():
                            if ExifTags.TAGS[orientation] == 'Orientation':
                                break
                    
                        exif = image._getexif()
                    
                        if exif is not None:
                            orientation = exif.get(orientation)
                        if orientation == 3:
                            image = image.rotate(180, expand=True)
                        elif orientation == 6:
                            image = image.rotate(270, expand=True)
                        elif orientation == 8:
                            image = image.rotate(90, expand=True)
                    except:
                        pass   
                    #same as image.resize but keeping the ratio ;-)
                    
                    image.thumbnail((widthThumbsnail, widthThumbsnail))
                    image.save(path.split('.')[0]+".png")
                    print("changing type to thumbsnail")
                    print(response)
                    response[i]["type"] = "thumbsnail"
                    response[i]["location"] = response[i]["location"].split('.')[0]+".png"
                    print(response)

            #operation pour image/video normale
            else:
                if files[i]["content_type"].find("video") != -1:
                    print("video1")
                    try:
                        clip = VideoFileClip(path)
                    except:
                        print("ERREUR de path")
                        submission.provided="Erreur de traitement de la soumission"
                        db.session.commit()
                        return
                    
                    os.remove(path)
                    
                    if clip.rotation == 90:
                        clip = clip.resize(clip.size[::-1])
                        clip.rotation = 0
                    
                    clip_resized = clip.resize((width*(clip.size[0]/clip.size[1]), 
                    width))
                    
                    clip_resized = clip_resized.set_fps(fps) 
                    try:
                        print(path.split('.')[0]+".webm")
                        clip_resized.write_videofile(path.split('.')[0]+".webm", codec="libvpx", temp_audiofile=path.split('.')[0]+".ogg")
                    except Exception as e:
                        current_app.logger.error(f"Erreur de traitement de la vidéo: {e}")
                        return {"success": False, "errors": str(e)}, 500
                    
                    print("changing type to video/webm and location")
                    print(response)
                    response[i]["type"] = "video/webm"
                    response[i]["location"] = response[i]["location"].split('.')[0]+".webm"
                    print(response)
                #  clip_resized.write_audiofile(path.split('.')[0]+".ogg", codec="libvpx", temp_audiofile=/tmp/random_name.mp3)
                elif files[i]["content_type"].find("image") != -1:
                    print("image1")
                    image = Image.open(path)
                    os.remove(path)
                    #changer orientation
                    try:
                        for orientation in ExifTags.TAGS.keys():
                            if ExifTags.TAGS[orientation] == 'Orientation':
                                break
                    
                        exif = image._getexif()
                    
                        if exif is not None:
                            orientation = exif.get(orientation)
                        if orientation == 3:
                            image = image.rotate(180, expand=True)
                        elif orientation == 6:
                            image = image.rotate(270, expand=True)
                        elif orientation == 8:
                            image = image.rotate(90, expand=True)
                    except:
                        pass         

                    #same as image.resize but keeping the ratio ;-)
                    image.thumbnail((width,width*(image.size[1]/image.size[0])))
                    image.save(path.split('.')[0]+".png")
                    print("changing type to image/png")
                    print(response)
                    response[i]["type"] = "image/png"
                    response[i]["location"] = response[i]["location"].split('.')[0]+".png"
                    print(response)
                

        submission = Submissions.query.filter_by(id=submission.id).first_or_404()
        
        submission.provided = json.dumps(response)
        
        db.session.commit()
            
        print("final return")
        print(response)
        print(submission.provided)
    except():
        print("Erreur de traitement de la soumission!")
        submission.provided = "Erreur de traitement de la soumission!"
        db.session.commit()


def filterSubmissions() -> bool:
    print("\033[1;34m" + "="*50 + "\033[0m")
    print("\033[1;32mProcessing files!\033[0m")
    print("\033[1;34m" + "="*50 + "\033[0m")
    
    app = create_app()
    isFileProcessed = False
    
    with app.app_context():
        # submissions = Submissions.query.order_by(Submissions.date.desc()).all()
        Model = get_model()
        submissions = (
            Submissions.query
            .join(Challenges)
            .order_by(Submissions.date.desc())
        )
        for i, submission in enumerate(submissions):
            if submission.provided == "Média en traitement":
                isFileProcessed = True
                print(f"\033[1;33m--> Processing submission {i}: {submission.id}\033[0m")
                print(f"\033[1;33m--> Submission heavyData {i}: {submission.heavyData}\033[0m")
                print(f"\033[1;33m--> Submission response {i}: {submission.response}\033[0m")
                print(f"\033[1;33m--> Submission files_data {i}: {submission.files_data}\033[0m")
                print(f"\033[1;33m--> Submission vraiType {i}: {submission.vraiType}\033[0m")
                processFiles(submission)
    
    print("\033[1;34m" + "="*50 + "\033[0m")
    return isFileProcessed  # Adjust return value based on actual logic

def main():
    time.sleep(15)
    while True:
        if filterSubmissions():
            pass
        else:
            print("\033[1;34m" + "="*50 + "\033[0m")
            print("\033[1;31mNo more files to process, back to sleep ...ZzZ...\033[0m")
            print("\033[1;34m" + "="*50 + "\033[0m")
            time.sleep(30)


if __name__ == "__main__":
    main()

